<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
>
    <!-- this page is a template and must be included using a s:decorate element
          parameters: managedBean
          insert names: generalInformation, detailedResult, fileContent
       -->
    <s:div id="validationResultPanel" rendered="#{managedBean.selectedObject != null}">

        <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

            <!-- Title -->

            <ui:param name="panel_id" value="resultPanel"/>
            <ui:define name="panel_title">
                <ui:include src="/common/informationHeader.xhtml">
                    <ui:param name="resultGui" value="#{managedBean}"/>
                    <ui:param name="idToRender" value="resultPanel"/>
                </ui:include>
            </ui:define>

            <!-- general information -->

                <ui:define name="panel_title">
                    <ui:include src="/common/informationHeader.xhtml">
                        <ui:param name="resultGui" value="#{managedBean}"/>
                        <ui:param name="idToRender" value="generalInfoPanel"/>
                    </ui:include>
                </ui:define>
                <ui:param name="panel_id" value="generalInfoPanel"/>

                <dl class="dl-horizontal">

                    <dt class="#{dt_styleClass}">
                        #{messages['gazelle.evs.client.cda.filename']}
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <h:outputText value="#{managedBean.selectedObject.object.originalFileName}"/>
                        <h:commandLink action="#{managedBean.downloadValidatedObject()}">
                            <s:span title="#{messages['gazelle.evs.DownloadFile']}" styleClass="gzl-icon-download text-info"/>
                        </h:commandLink>
                    </dd>

                    <dt class="#{dt_styleClass}">
                        #{messages['gazelle.evs.client.cda.oid']} :
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <h:outputText value="#{managedBean.selectedObject.oid}"/>
                    </dd>

                    <dt class="#{dt_styleClass}">
                        #{messages['gazelle.evs.client.validation.date']} :
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <g:date date="true" time="true"
                                value="#{managedBean.selectedObject.date}" tooltip="false"/>
                    </dd>

                    <dt class="#{dt_styleClass}">
                        <h:outputText value="#{managedBean.getValidationServiceName()} :"/>
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <h:outputText value="#{managedBean.getValidatorName()}"/>
                        <h:outputText
                                value=" (#{messages['net.ihe.gazelle.xval.Version']} #{managedBean.detailedResult.validationResultsOverview.validationServiceVersion})"
                                rendered="#{managedBean.detailedResult.validationResultsOverview.validationServiceVersion != null}"/>
                        <h:outputText
                                value=" (#{messages['net.ihe.gazelle.xval.Version']} #{messages['net.ihe.gazelle.evs.NA']})"
                                rendered="#{managedBean.detailedResult.validationResultsOverview.validationServiceVersion == null}"/>
                    </dd>

                    <dt class="#{dt_styleClass}">
                        <h:outputText value="#{messages['net.ihe.gazelle.evsclient.ValidationResults']} :"/>
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <h:outputText styleClass="#{managedBean.getValidationStatus() == 'VALIDATION NOT PERFORMED'? 'gzl-label gzl-label-grey' : managedBean.getValidationStatus()}"
                                      value="#{managedBean.getValidationStatus()}"/>
                        <h:commandLink action="#{managedBean.downloadResultAsXml()}"
                                       rendered="#{managedBean.getValidatorName() != null}" execute="@form">
                            <s:span title="#{messages['net.ihe.gazelle.EVSClient-ui.DownloadValidationResultsXML']})"
                                    styleClass="gzl-icon-download text-info"/>
                        </h:commandLink>


                        <h:commandLink action="#{managedBean.downloadReportAsPdf()}"
                                   rendered="#{managedBean.getValidatorName() != null and managedBean.detailedResult != null }">
                        <s:span title="#{messages['net.ihe.gazelle.EVSClient-ui.DownloadValidationResultsPDF']})"
                                styleClass="gzl-icon-pdf"/>
                        </h:commandLink>

                    </dd>

                    <!-- TODO extension etc
                    <s:span rendered="#{not empty managedBean.selectedObject.signatureValidationStatus}">
                        <dt class="#{dt_styleClass}">
                        #{messages['net.ihe.gazelle.evs.SignatureValidationResult']}
                        </dt>
                        <dd class="#{dd_styleClass}">
                        <h:outputText styleClass="#{resultDisplayManager.selectedObject.signatureValidationStatus}"
                                      value="#{resultDisplayManager.selectedObject.signatureValidationStatus}"/>
                        <h:commandLink action="#{resultDisplayManager.downloadResultAsXml('signature_validation')}">
                            <s:span title="#{messages['net.ihe.gazelle.EVSClient-ui.DownloadValidationResultsXML']})"
                                    styleClass="gzl-icon-download text-info"/>
                        </h:commandLink>
                        </dd>
                    </s:span>
                    -->

                    <dt class="#{dt_styleClass}">
                        #{messages['gazelle.evs.client.Permanent.Link']} :
                    </dt>
                    <dd class="#{dd_styleClass}">
                        <h:outputLink value="#{managedBean.getPermanentLink(managedBean.selectedObject)}"
                                      target="_blank">
                            <h:outputText value="#{managedBean.getPermanentLink(managedBean.selectedObject)}"/>
                        </h:outputLink>
                    </dd>
                    <dt class="#{dt_styleClass}">
                        #{messages['net.ihe.gazelle.evsclient.DataVisibility']}
                    </dt>
                    <dd class="#{dd_styleClass}" id="nameInput">
                        <h:outputText rendered="#{!managedBean.selectedObject.sharing.isPrivate}"
                                      value="#{messages['net.ihe.gazelle.evsclient.Public']}"/>
                        <h:outputText
                                rendered="#{managedBean.selectedObject.sharing.isPrivate
				                and managedBean.selectedObject.sharing.privacyKey == null}"
                                value="#{messages['net.ihe.gazelle.evsclient.Private']}"/>
                        <h:outputText rendered="#{managedBean.selectedObject.privacyKey != null}"
                                      value="#{messages['net.ihe.gazelle.EVSClient-ui.Shared']}"/>
                        <h:outputText
                                rendered="#{identity.loggedIn and not empty managedBean.selectedObject.owner.username}"
                                value=" - #{messages['net.ihe.gazelle.evsclient.OwnedBy']} #{managedBean.getUserName(managedBean.selectedObject.owner.username)} / #{managedBean.selectedObject.owner.organization}"/>
                    </dd>
                </dl>

                <ui:insert name="generalInformation"/>

            <ui:define name="panel_footer">
                <ui:include src="/common/informationFooter.xhtml">
                    <ui:param name="resultGui" value="#{managedBean}"/>
                    <ui:param name="idToRender" value="generalInfoPanel"/>
                </ui:include>

            </ui:define>
        </ui:decorate>

        <!-- detailed results -->

        <ui:decorate template="/layout/panels/_panel_title.xhtml">

            <ui:param name="panel_id" value="validationResultsPanel"/>

            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.evsclient.ValidationResults']}"/>
            </ui:define>

            <gri:tabPanel withBorder="true" activeItem="default">
                <gri:tab id="default" head="#{managedBean.selectedObject.validationService.name}"
                         rendered="#{managedBean.selectedObject.validationService != null}">
                    <s:div styleClass="row" id="no-details" rendered="#{managedBean.detailedResult == null}">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.NotAvailable']}"/>
                    </s:div>
                    <s:div styleClass="row" id="details" rendered="#{managedBean.detailedResult != null}">
                        <s:div style="padding:0px 15px">
                            <h:outputText value="#{managedBean.getTransformedDetailedResult()}"
                                          escape="false"/>
                        </s:div>
                    </s:div>
                </gri:tab>
                <gri:tab id="validationReportTab" head="#{messages['gazelle.evs.client.hl7.XMLMessageContent']}"
                         rendered="#{managedBean.selectedObject.validationReport != null and managedBean.detailedResult == null}">
                    <s:div styleClass="document-short-viewer" id="validationReport">
                        <s:div styleClass="col-md-9">
                            <h:outputText value="#{managedBean.renderValidationReport()}"
                                          escape="false"/>
                        </s:div>
                    </s:div>
                </gri:tab>
            </gri:tabPanel>
        </ui:decorate>


        <!-- file content -->
        <ui:decorate template="/layout/panels/_panel_title_id.xhtml">

            <ui:param name="panel_id" value="fileContentPanel"/>
            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.evs.FileContent']}"/>
            </ui:define>
            <ui:insert name="fileContent"/>

        </ui:decorate>

    </s:div>
    <s:div id="badid" rendered="#{managedBean.selectedObject == null}">
        <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
            <ui:param name="panel_id" value="badidPanel"/>
            <ui:define name="panel_title">
                <h:outputText value="#{messages['gazelle.evs.client.cda.unknown.id']}"/>
            </ui:define>
            #{messages['net.ihe.gazelle.EVSClient-ui.CouldNotFindAnObjectInTheDatabaseCorrespondingTo']}
        </ui:decorate>
    </s:div>

    <ui:include src="/common/sendToProxyPanel4XmlBasedFiles.xhtml">
        <ui:param name="validationResultBeanGui" value="#{managedBean}"/>
    </ui:include>
</ui:composition>
